package jnv.hostlist;

import java.util.Collection;
import java.util.Iterator;
import jnv.hostlist.*;
import java.io.*;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class NVNvhProc{

  public NVNvhProc() {
  }

  static public void SaveHostList(NVHostList hostlist, String fname)throws IOException{
  FileOutputStream s=new FileOutputStream(fname);
  for(int i=0;i<hostlist.size();i++)
   {
   NVHost h=hostlist.getHostAt(i);
   Enumeration en=h.getVarNames();
   String hip=h.getIp();
   if(hip.length()!=0)
    {
    s.write(hip.getBytes());
    s.write("\t".getBytes());
    }else s.write("-\t".getBytes());
   s.write(nvh_esc_format(h.getHostname()).getBytes());
   s.write("\t##".getBytes());
   while(en.hasMoreElements())
    {
    String varname=(String)en.nextElement();
    String vardata=h.getMetaVar(varname);
    if(vardata.length()!=0)
     {
     s.write("$".getBytes());
     s.write(nvh_esc_format(varname).getBytes());
     s.write("=".getBytes());
     s.write(nvh_esc_format(vardata).getBytes());
     s.write("$".getBytes());
     }
    }
   s.write("#\r\n".getBytes());
   }
  s.close();
  }

  static public void LoadHostList(NVHostList hostlist, String fname)throws IOException{
  FileInputStream s=new FileInputStream(fname);
  InputStreamReader rd=new InputStreamReader(s);
  StringBuffer strbuf= new StringBuffer();
  char buf[]=new char[0xffff];
  for(;;)
   {
   int len=rd.read(buf);
   if(len<=0)break;
   int oldlen=strbuf.length();
   strbuf.setLength(oldlen+len);
   for(int i=oldlen;i<oldlen+len;i++)strbuf.setCharAt(i,(char)buf[i-oldlen]);
   int j=0;
   for(int i=0;i<strbuf.length();i++)
   if((strbuf.charAt(i)=='\r')||(strbuf.charAt(i)=='\n'))
    {
    String xs=strbuf.substring(j,i);
    if((xs.length()>0)&&(xs.charAt(0)!='#'))ParseHostStr(xs,hostlist);
    while((i<strbuf.length())&&((strbuf.charAt(i)=='\r')||(strbuf.charAt(i)=='\n')))i++;
    j=i;
    }
   if(j!=0)strbuf.delete(0,j);
   }
  s.close();
  }

  static public void ParseHostStr(String xs, NVHostList hostlist){
  int i;
  for(i=0;((i<xs.length())&&(xs.charAt(i)!=' ')&&(xs.charAt(i)!='\t'));i++);
  if(i<xs.length())
   {
   String hip=xs.substring(0,i);
   for(;((i<xs.length())&&((xs.charAt(i)==' ')||(xs.charAt(i)=='\t')));i++);
   if(i<xs.length())
    {
    int j=i;
    for(;((i<xs.length())&&(xs.charAt(i)!=' ')&&(xs.charAt(i)!='\t')&&(xs.charAt(i)!='#'));i++);
    if(i<xs.length())
     {
     String hname=nvh_esc_unformat(xs.substring(j,i));
     NVHost h=hostlist.putHost(hname,hip);
     for(;((i<xs.length())&&((xs.charAt(i)==' ')||(xs.charAt(i)=='\t')||(xs.charAt(i)=='#')));i++);
     if(i<xs.length())
      {
      boolean olddiv=true;
      j=i;
      for(;(i<xs.length());i++)
       {
       boolean curdiv=(xs.charAt(i)=='$');
       if(curdiv!=olddiv)
        {
        if(curdiv)
         {
         String mv=xs.substring(j,i);
         int x=mv.indexOf('=');
         if(x!=-1)
          {
          String varname=nvh_esc_unformat(mv.substring(0,x));
          String vardata=nvh_esc_unformat(mv.substring(x+1,mv.length()));
          h.setMetaVar(varname,vardata);
          }
         }else j=i;
        olddiv=curdiv;
        }
       }
      }
     }
    }
   }
  }





  static public String nvh_esc_unformat(String s)
  {
  StringBuffer ret=new StringBuffer();//s.length());
  ret.setLength(s.length());

  int j=0;
  for(int i=0;i<s.length();i++)
   {
   char ch=s.charAt(i);
   if((ch=='\\')&&((i+1)<s.length()))
    switch(ch=s.charAt(++i))
     {
     case '1':ch='\r';break;
     case '2':ch='\n';break;
     case '3':ch='\0';break;
     case '4':ch='$';break;
     case '5':ch='#';break;
     case '6':ch='=';break;
     case '7':ch='\\';break;
     case '8':ch='\t';break;
     case '9':ch=' ';break;
     }
   ret.setCharAt(j++,ch);
   }
  return ret.substring(0,j);
  }

  static public String nvh_esc_format(String s)
  {
  StringBuffer ret=new StringBuffer();//2*s.length());
  ret.setLength(2*s.length());

  int j=0;
  for(int i=0;i<s.length();i++)
   {
   char ch=s.charAt(i);
   boolean escaped;
   switch(ch)
    {
    case '\r':escaped=true;ch='1';break;
    case '\n':escaped=true;ch='2';break;
    case '\0':escaped=true;ch='3';break;
    case '$' :escaped=true;ch='4';break;
    case '#' :escaped=true;ch='5';break;
    case '=' :escaped=true;ch='6';break;
    case '\\':escaped=true;ch='7';break;
    case '\t':escaped=true;ch='8';break;
    case ' ' :escaped=true;ch='9';break;
    default  :escaped=false;
    }
   if(escaped)ret.setCharAt(j++,'\\');
   ret.setCharAt(j++,ch);
   }
  return ret.substring(0,j);
  }
}